﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace PDFToJPGExpert
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            
            ExceptionHandlersHelper.AddUnhandledExceptionHandlers();

            frmLanguage.SetLanguages();
            SetLanguage();


            if (args.Length > 0 && args[0].StartsWith("/uninstall"))
            {
                frmUninstallQuestionnaire fq = new frmUninstallQuestionnaire();
                fq.ShowDialog();
                Environment.Exit(0);
                return;
            }


            Application.Run(new frmMain());
        }

        public static void SetLanguage()
        {
            string lang = Properties.Settings.Default.Language;

            if (Properties.Settings.Default.LastVersion != Module.ApplicationTitle)
            {
                Properties.Settings.Default.LanguagesDownloaded = "";
                Properties.Settings.Default.LastVersion = Module.ApplicationTitle;
                Properties.Settings.Default.Save();
            }
            
            bool setlang = false;

            if (Properties.Settings.Default.Language == string.Empty)
            {
                frmLanguage fl = new frmLanguage();
                fl.ShowDialog();
                Properties.Settings.Default.Language = frmLanguage.SelectedLanguageCode;
                lang = frmLanguage.SelectedLanguageCode;
                setlang = true;
            }
            
            Module.SelectedLanguage = lang;

            if (lang != "en-US")
            {
                if (!frmLanguage.DownloadLanguage(lang))
                {
                    lang = "en-US";
                    Properties.Settings.Default.Language = "en-US";
                }
            }
            
            if (lang == "en-US")
            {
                System.Threading.Thread.CurrentThread.CurrentUICulture =
                    System.Globalization.CultureInfo.InvariantCulture;

                //Application.CurrentCulture = System.Globalization.CultureInfo.InvariantCulture;
            }
            else
            {               
                try
                {
                    System.Threading.Thread.CurrentThread.CurrentUICulture = new
                    System.Globalization.CultureInfo(lang);

                    //Application.CurrentCulture = new System.Globalization.CultureInfo(lang);
                }
                catch (Exception ex)
                {
                    Module.ShowError(ex);
                }
            }

            /*
            if (setlang)
            {
                key.SetValue("Menu Item Caption", TranslateHelper.Translate("Remove PDF Password"));
            }
            */
        }         
    }
}
