using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PDFToJPGExpert
{
    public partial class frmProgress : CustomForm
    {
        public static frmProgress Instance = null;
        
        public frmProgress()
        {
            InitializeComponent();
            Instance = this;
            this.Owner = frmMain.Instance;
            this.Show();
        }

        private delegate void UpdateDelegate();
        

        public void UpdateProgress()
        {
            if (this.InvokeRequired)
                this.Invoke((UpdateDelegate)UpdateProgress, null);
            else
            {
                if ((progressBar1.Value + 1) < progressBar1.Maximum)
                {
                    progressBar1.Value++;
                }
            }
        }

        private delegate void CloseDelegate();


        public void CloseForm()
        {
            if (this.InvokeRequired)
                this.Invoke((UpdateDelegate)CloseForm, null);
            else
            {
                this.Close();
            }
        }

        
        

        private void btnCancel_Click(object sender, EventArgs e)
        {
            //PDFToJPGHelper.LastConvert.DestroyInstance();
            //PdfToImage.PDFConvert.CANCEL = true;
            PDFToJPGHelper.LastConvert.CancelExecution();
            PDFToJPGHelper.CANCELLED = true;

        }

        private void frmProgress_Load(object sender, EventArgs e)
        {
            if (frmMain.fs.Path != string.Empty)
            {
                frmMain.fs.EnableRaisingEvents = true;
            }
        }

        private void frmProgress_FormClosed(object sender, FormClosedEventArgs e)
        {
            frmMain.fs.EnableRaisingEvents = false;
        }

        private void timPaint_Tick(object sender, EventArgs e)
        {
            Application.DoEvents();
        }
    }
}

